'use strict';

module.exports = {
	IsPropertyDescriptor: 'https://ecma-international.org/ecma-262/6.0/#sec-property-descriptor-specification-type', // not actually an abstract op

	'Abstract Equality Comparison': 'https://ecma-international.org/ecma-262/6.0/#sec-abstract-equality-comparison',
	'Abstract Relational Comparison': 'https://ecma-international.org/ecma-262/6.0/#sec-abstract-relational-comparison',
	'Strict Equality Comparison': 'https://ecma-international.org/ecma-262/6.0/#sec-strict-equality-comparison',
	AdvanceStringIndex: 'https://ecma-international.org/ecma-262/6.0/#sec-advancestringindex',
	ArrayCreate: 'https://ecma-international.org/ecma-262/6.0/#sec-arraycreate',
	ArraySetLength: 'https://ecma-international.org/ecma-262/6.0/#sec-arraysetlength',
	ArraySpeciesCreate: 'https://ecma-international.org/ecma-262/6.0/#sec-arrayspeciescreate',
	Call: 'https://ecma-international.org/ecma-262/6.0/#sec-call',
	CanonicalNumericIndexString: 'https://ecma-international.org/ecma-262/6.0/#sec-canonicalnumericindexstring',
	CompletePropertyDescriptor: 'https://ecma-international.org/ecma-262/6.0/#sec-completepropertydescriptor',
	Construct: 'https://ecma-international.org/ecma-262/6.0/#sec-construct',
	CreateArrayFromList: 'https://ecma-international.org/ecma-262/6.0/#sec-createarrayfromlist',
	CreateDataProperty: 'https://ecma-international.org/ecma-262/6.0/#sec-createdataproperty',
	CreateDataPropertyOrThrow: 'https://ecma-international.org/ecma-262/6.0/#sec-createdatapropertyorthrow',
	CreateHTML: 'https://ecma-international.org/ecma-262/6.0/#sec-createhtml',
	CreateIterResultObject: 'https://ecma-international.org/ecma-262/6.0/#sec-createiterresultobject',
	CreateListFromArrayLike: 'https://ecma-international.org/ecma-262/6.0/#sec-createlistfromarraylike',
	CreateListIterator: 'https://ecma-international.org/ecma-262/6.0/#sec-createlistiterator',
	CreateMethodProperty: 'https://ecma-international.org/ecma-262/6.0/#sec-createmethodproperty',
	DateFromTime: 'https://ecma-international.org/ecma-262/6.0/#sec-date-number',
	Day: 'https://ecma-international.org/ecma-262/6.0/#sec-day-number-and-time-within-day',
	DayFromYear: 'https://ecma-international.org/ecma-262/6.0/#sec-year-number',
	DaysInYear: 'https://ecma-international.org/ecma-262/6.0/#sec-year-number',
	DayWithinYear: 'https://ecma-international.org/ecma-262/6.0/#sec-month-number',
	DefinePropertyOrThrow: 'https://ecma-international.org/ecma-262/6.0/#sec-definepropertyorthrow',
	DeletePropertyOrThrow: 'https://ecma-international.org/ecma-262/6.0/#sec-deletepropertyorthrow',
	EnumerableOwnNames: 'https://ecma-international.org/ecma-262/6.0/#sec-enumerableownnames',
	FromPropertyDescriptor: 'https://ecma-international.org/ecma-262/6.0/#sec-frompropertydescriptor',
	Get: 'https://ecma-international.org/ecma-262/6.0/#sec-get-o-p',
	GetIterator: 'https://ecma-international.org/ecma-262/6.0/#sec-getiterator',
	GetMethod: 'https://ecma-international.org/ecma-262/6.0/#sec-getmethod',
	GetOwnPropertyKeys: 'https://ecma-international.org/ecma-262/6.0/#sec-getownpropertykeys',
	GetPrototypeFromConstructor: 'https://ecma-international.org/ecma-262/6.0/#sec-getprototypefromconstructor',
	GetSubstitution: 'https://ecma-international.org/ecma-262/6.0/#sec-getsubstitution',
	GetV: 'https://ecma-international.org/ecma-262/6.0/#sec-getv',
	HasOwnProperty: 'https://ecma-international.org/ecma-262/6.0/#sec-hasownproperty',
	HasProperty: 'https://ecma-international.org/ecma-262/6.0/#sec-hasproperty',
	HourFromTime: 'https://ecma-international.org/ecma-262/6.0/#sec-hours-minutes-second-and-milliseconds',
	InLeapYear: 'https://ecma-international.org/ecma-262/6.0/#sec-year-number',
	InstanceofOperator: 'https://ecma-international.org/ecma-262/6.0/#sec-instanceofoperator',
	Invoke: 'https://ecma-international.org/ecma-262/6.0/#sec-invoke',
	IsAccessorDescriptor: 'https://ecma-international.org/ecma-262/6.0/#sec-isaccessordescriptor',
	IsArray: 'https://ecma-international.org/ecma-262/6.0/#sec-isarray',
	IsCallable: 'https://ecma-international.org/ecma-262/6.0/#sec-iscallable',
	IsConcatSpreadable: 'https://ecma-international.org/ecma-262/6.0/#sec-isconcatspreadable',
	IsConstructor: 'https://ecma-international.org/ecma-262/6.0/#sec-isconstructor',
	IsDataDescriptor: 'https://ecma-international.org/ecma-262/6.0/#sec-isdatadescriptor',
	IsExtensible: 'https://ecma-international.org/ecma-262/6.0/#sec-isextensible-o',
	IsGenericDescriptor: 'https://ecma-international.org/ecma-262/6.0/#sec-isgenericdescriptor',
	IsInteger: 'https://ecma-international.org/ecma-262/6.0/#sec-isinteger',
	IsPromise: 'https://ecma-international.org/ecma-262/6.0/#sec-ispromise',
	IsPropertyKey: 'https://ecma-international.org/ecma-262/6.0/#sec-ispropertykey',
	IsRegExp: 'https://ecma-international.org/ecma-262/6.0/#sec-isregexp',
	IteratorClose: 'https://ecma-international.org/ecma-262/6.0/#sec-iteratorclose',
	IteratorComplete: 'https://ecma-international.org/ecma-262/6.0/#sec-iteratorcomplete',
	IteratorNext: 'https://ecma-international.org/ecma-262/6.0/#sec-iteratornext',
	IteratorStep: 'https://ecma-international.org/ecma-262/6.0/#sec-iteratorstep',
	IteratorValue: 'https://ecma-international.org/ecma-262/6.0/#sec-iteratorvalue',
	MakeDate: 'https://ecma-international.org/ecma-262/6.0/#sec-makedate',
	MakeDay: 'https://ecma-international.org/ecma-262/6.0/#sec-makeday',
	MakeTime: 'https://ecma-international.org/ecma-262/6.0/#sec-maketime',
	MinFromTime: 'https://ecma-international.org/ecma-262/6.0/#sec-hours-minutes-second-and-milliseconds',
	modulo: 'https://ecma-international.org/ecma-262/6.0/#sec-algorithm-conventions',
	MonthFromTime: 'https://ecma-international.org/ecma-262/6.0/#sec-month-number',
	msFromTime: 'https://ecma-international.org/ecma-262/6.0/#sec-hours-minutes-second-and-milliseconds',
	NormalCompletion: 'https://ecma-international.org/ecma-262/6.0/#sec-normalcompletion',
	ObjectCreate: 'https://ecma-international.org/ecma-262/6.0/#sec-objectcreate',
	OrdinaryDefineOwnProperty: 'https://ecma-international.org/ecma-262/6.0/#sec-ordinarydefineownproperty',
	OrdinaryGetOwnProperty: 'https://ecma-international.org/ecma-262/6.0/#sec-ordinarygetownproperty',
	OrdinaryHasInstance: 'https://ecma-international.org/ecma-262/6.0/#sec-ordinaryhasinstance',
	OrdinaryHasProperty: 'https://ecma-international.org/ecma-262/6.0/#sec-ordinaryhasproperty',
	RegExpBuiltinExec: 'https://ecma-international.org/ecma-262/6.0/#sec-regexpbuiltinexec',
	RegExpExec: 'https://ecma-international.org/ecma-262/6.0/#sec-regexpexec',
	RequireObjectCoercible: 'https://ecma-international.org/ecma-262/6.0/#sec-requireobjectcoercible',
	SameValue: 'https://ecma-international.org/ecma-262/6.0/#sec-samevalue',
	SameValueZero: 'https://ecma-international.org/ecma-262/6.0/#sec-samevaluezero',
	SecFromTime: 'https://ecma-international.org/ecma-262/6.0/#sec-hours-minutes-second-and-milliseconds',
	Set: 'https://ecma-international.org/ecma-262/6.0/#sec-set-o-p-v-throw',
	SetFunctionName: 'https://ecma-international.org/ecma-262/6.0/#sec-setfunctionname',
	SetIntegrityLevel: 'https://ecma-international.org/ecma-262/6.0/#sec-setintegritylevel',
	SpeciesConstructor: 'https://ecma-international.org/ecma-262/6.0/#sec-speciesconstructor',
	SymbolDescriptiveString: 'https://ecma-international.org/ecma-262/6.0/#sec-symboldescriptivestring',
	TestIntegrityLevel: 'https://ecma-international.org/ecma-262/6.0/#sec-testintegritylevel',
	thisBooleanValue: 'https://ecma-international.org/ecma-262/6.0/#sec-properties-of-the-boolean-prototype-object',
	thisNumberValue: 'https://ecma-international.org/ecma-262/6.0/#sec-properties-of-the-number-prototype-object',
	thisStringValue: 'https://ecma-international.org/ecma-262/6.0/#sec-properties-of-the-string-prototype-object',
	thisTimeValue: 'https://ecma-international.org/ecma-262/6.0/#sec-properties-of-the-date-prototype-object',
	TimeClip: 'https://ecma-international.org/ecma-262/6.0/#sec-timeclip',
	TimeFromYear: 'https://ecma-international.org/ecma-262/6.0/#sec-year-number',
	TimeWithinDay: 'https://ecma-international.org/ecma-262/6.0/#sec-day-number-and-time-within-day',
	ToBoolean: 'https://ecma-international.org/ecma-262/6.0/#sec-toboolean',
	ToDateString: 'https://ecma-international.org/ecma-262/6.0/#sec-todatestring',
	ToInt16: 'https://ecma-international.org/ecma-262/6.0/#sec-toint16',
	ToInt32: 'https://ecma-international.org/ecma-262/6.0/#sec-toint32',
	ToInt8: 'https://ecma-international.org/ecma-262/6.0/#sec-toint8',
	ToInteger: 'https://ecma-international.org/ecma-262/6.0/#sec-tointeger',
	ToLength: 'https://ecma-international.org/ecma-262/6.0/#sec-tolength',
	ToNumber: 'https://ecma-international.org/ecma-262/6.0/#sec-tonumber',
	ToObject: 'https://ecma-international.org/ecma-262/6.0/#sec-toobject',
	ToPrimitive: 'https://ecma-international.org/ecma-262/6.0/#sec-toprimitive',
	ToPropertyDescriptor: 'https://ecma-international.org/ecma-262/6.0/#sec-topropertydescriptor',
	ToPropertyKey: 'https://ecma-international.org/ecma-262/6.0/#sec-topropertykey',
	ToString: 'https://ecma-international.org/ecma-262/6.0/#sec-tostring',
	ToUint16: 'https://ecma-international.org/ecma-262/6.0/#sec-touint16',
	ToUint32: 'https://ecma-international.org/ecma-262/6.0/#sec-touint32',
	ToUint8: 'https://ecma-international.org/ecma-262/6.0/#sec-touint8',
	ToUint8Clamp: 'https://ecma-international.org/ecma-262/6.0/#sec-touint8clamp',
	Type: 'https://ecma-international.org/ecma-262/6.0/#sec-ecmascript-language-types',
	ValidateAndApplyPropertyDescriptor: 'https://ecma-international.org/ecma-262/6.0/#sec-validateandapplypropertydescriptor',
	WeekDay: 'https://ecma-international.org/ecma-262/6.0/#sec-week-day',
	YearFromTime: 'https://ecma-international.org/ecma-262/6.0/#sec-year-number'
};
